#include <stdint.h>
#include "datum.h"

#define JD2000 2451545.0

uint8_t Monatstage[2][12] = { { 31,28,31,30,31,30,31,31,30,31,30,31 }, { 31,29,31,30,31,30,31,31,30,31,30,31 } };

uint8_t Schaltjahr( uint16_t Jahr ) {

	if ( Jahr % 4 == 0 ) {
		if ( Jahr < 1582 ) return 1;
		else {
			if ( !( Jahr % 100 == 0 ) ) return 1;
			else if ( Jahr % 400 == 0 ) return 1;
  		}
 	}

	return 0;
}

double JahrhunderteSeit2000( Datum_t Datum ) {

	int8_t A;
	uint16_t C;
	uint32_t B;

	if ( Datum.Monat <= 2 ) {
		Datum.Jahr -= 1;
		Datum.Monat += 12;
	}

	A = 2 - Datum.Jahr * 0.01 + Datum.Jahr * 2.5e-3;
	B = 365.25 * ( Datum.Jahr + 4716 );
	C = 30.6001 * ( Datum.Monat + 1 );
	
	return ( A + B + C + Datum.Tag - 1524 - JD2000 ) / 36525;
}
